# -*- coding: utf -*-
from __future__ import unicode_literals

from driverng.protocol.acknack import ACKNACKProtocol


class Au680Protocol(ACKNACKProtocol):

    def __init__(self, **kwargs):
        kwargs.setdefault("checksum_type", self.CHECKSUM_BCC)
        super(Au680Protocol, self).__init__(**kwargs)

    def send_trames(self, trame):
        sent = super(Au680Protocol, self).send_trames(trame)
        if sent and trame[1] == b"S":
            self.write(self.build_trames(b"SE"))
            return True
        else:
            return sent

    def recv_trames(self):
        payload = super(Au680Protocol, self).recv_trames()
        if payload and payload[:2] in (b"DE", b"DB", b"SE", b"RB", b"RE"):
            return []
        else:
            return payload
