# -*- coding: utf8 -*-
from __future__ import unicode_literals

from driverng.utils import STX, ETX, ETB, byte2log
from driverng.protocol.base import BaseProtocol


class Ha81Protocol(BaseProtocol):
    """HA81 Uni

    <stx>payload0<etb>
    <stx>payload1<etb>
    <stx>payload2<etx>
    """

    def build_trames(self, message):
        return "%c%s%c" % (STX, message, ETX)

    def send_trames(self, trame):
        self.write(trame)
        return True

    def recv_trames(self):
        data = self.readline(break_func=lambda s: s and s[-1] == ETX)
        if not data or data[0] != STX:
            self.logger.warning("<stx> expected in '%s'", byte2log(data))
            return False
        return data[1:-1].replace(ETB, b"")
