# -*- coding: utf8 -*-
from __future__ import unicode_literals

from driverng.protocol.base import BaseProtocol


class NoAstmProtocol(BaseProtocol):

    def __init__(self, *args, **kwargs):
        self.buf = b""
        super(NoAstmProtocol, self).__init__(*args, **kwargs)

    def send_trames(self, trames):
        self.write(trames)
        return True

    def build_trames(self, message):
        return b"\r".join(message.splitlines()) + b"\r"

    def recv_trames(self):
        messages = []
        while True:
            self.buf += self.read(size=4096)
            while True:
                try:
                    index = self.buf.index(b"\rL|1|N\r")
                except ValueError:
                    break
                messages.append(self.buf[:index + 7])
                self.buf = self.buf[index + 7:]
            if not self.buf:
                return messages
